/* The timer (speed throttler) driver for SDL.
   This code is a slightly modified version
   of the code used in FCEU.
*/

#include "keen.h"
#include <nds.h>

//#include "throttle.h"

static unsigned long tfreq;
static unsigned long desiredfps;

void RefreshThrottleFPS(void)
{
//       desiredfps=FCEUI_GetDesiredFPS()>>8;
//        desiredfps = 23000000;
  desiredfps = 21800000;
  tfreq=10000000;
  tfreq<<=16;    /* Adjustment for fps returned from FCEUI_GetDesiredFPS(). */
}

void SpeedThrottle(void)
{
//static unsigned long  ttime,ltime=0;

 poll_events();
/*
 waiter:
 
 ttime=SDL_GetTicks();
 ttime*=10000;

 //sprintf(lol,"(%lld-%lld) < (%lld/%lld)",ttime,ltime,tfreq,desiredfps);
 //AddConsoleMsg(lol);

 if( (ttime-ltime) < (tfreq/desiredfps) )
 {
  int64 delay;
  delay=(tfreq/desiredfps)-(ttime-ltime);
  //VidDrv_printf("%ld",delay);
  if(delay>0) 
   SDL_Delay(delay/10000);
  goto waiter;
 }
 if( (ttime-ltime) >= (tfreq*4/desiredfps))
  ltime=ttime;
 else
  ltime+=tfreq/desiredfps;*/
}

char TimeDrv_Start(void)
{
  RefreshThrottleFPS();
  //SDL_SetTimer(500, FPSCallback);
  return 0;
}

void TimeDrv_Stop(void)
{
  //SDL_SetTimer(0, NULL);
}

unsigned int FPSCallback(unsigned int interval)
{
  fps = (curfps << 1);
  curfps = 0;
  return interval;
}
